/***************************************************************************
*   Copyright (C) 2001 by Rick L. Vinyard, Jr.                            *
*   rvinyard@cs.nmsu.edu                                                  *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU Lesser General Public License as        *
*   published by the Free Software Foundation version 2.1.                *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU Lesser General Public      *
*   License along with this library; if not, write to the                 *
*   Free Software Foundation, Inc.,                                       *
*   51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA              *
***************************************************************************/
#ifndef CONEXUSGTKDATAPROGRESSWATCHER_H
#define CONEXUSGTKDATAPROGRESSWATCHER_H

#include <set>
#include <map>

#include <conexus/endpoint.h>

namespace ConexusGtk {

/**
 * @author Rick L Vinyard Jr <rvinyard@cs.nmsu.edu>
 */
class DataProgressWatcher{
public:
    DataProgressWatcher();

    ~DataProgressWatcher();

    void add_endpoint( Conexus::Endpoint& endpoint, bool watch_read=true, bool watch_write=true );
    
    void remove_endpoint( Conexus::Endpoint& endpoint );
    
  protected:
    unsigned m_data_count;

    typedef std::set<Conexus::Endpoint*> Endpoints;
    typedef std::map<Conexus::Endpoint*, sigc::connection> ConnectionMap;
    
    Endpoints m_endpoints;
    
    ConnectionMap m_read_connections;
    ConnectionMap m_write_connections;
    
    virtual void on_read_data( size_t n ) = 0;
    
    virtual void on_write_data( size_t n ) = 0;
    
  private:
    virtual void on_read_data_proxy( size_t n );
    
    virtual void on_write_data_proxy( size_t n );    


};

}

#endif
