/***************************************************************************
*   Copyright (C) 2001 by Rick L. Vinyard, Jr.                            *
*   rvinyard@cs.nmsu.edu                                                  *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU Lesser General Public License as        *
*   published by the Free Software Foundation version 2.1.                *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU Lesser General Public      *
*   License along with this library; if not, write to the                 *
*   Free Software Foundation, Inc.,                                       *
*   51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA              *
***************************************************************************/
#ifndef CONEXUSMMTTYPARITYERRORCOMBOBOX_H
#define CONEXUSMMTTYPARITYERRORCOMBOBOX_H

#include <gtkmm/comboboxtext.h>

#include <tr1/array>
#include <string>

#include <conexus/tty.h>

namespace ConexusGtk {

extern std::tr1::array<std::string,4> tty_parity_error_string;

/**
	@author Rick L Vinyard Jr <rvinyard@cs.nmsu.edu>
*/
class TTYParityErrorComboBox : public Gtk::ComboBoxText
{
public:
    TTYParityErrorComboBox(int active=3);

    ~TTYParityErrorComboBox();
    
    Conexus::ParityError parity_error();
    
    void set_parity_error(Conexus::ParityError error);

};

}

#endif
